#! /usr/bin/perl -w
# Generate input files for CombatSimulator

use strict;

my $combatsim = "BotE-CombatSimulator2D_2013-04_13b.exe" ; # this is the name of the combatsimulator you should use

my $fname = "ships.csv";
my @lines; # store lines from $fname here
my @shipdata;
my @major = (1 .. 6); 
my $i=0; my $j=0; my $k=0;
my $subpath;
my $pair;
my $rep = 100;
my @out;
my @table;
my @template;

my $start = time();
open(FILE, "<$fname") || die "can not find file $fname\n";
@lines = <FILE>;
close(FILE);

for($i=0; $i<=$#lines-1; $i++){
	$shipdata[$i] = [split(/;/,$lines[$i+1]) ];
}

print "$#shipdata\n";
print "$#{$shipdata[$#shipdata]}\n";


# there are symbols that are not UTF 8 and aren't displayed correctly. Therefore read in template of combatscript to avoid this
open(TEMPL, "<script_template.txt") || die "can not open script_template.txt\n";
	@template = <TEMPL>;
close(TEMPL);

# get rid of leading space
for($i=0; $i<= $#shipdata; $i++){
	if(substr($shipdata[$i][1],0,1) =~ /\s+/){ $shipdata[$i][1] = substr($shipdata[$i][1],1,length($shipdata[$i][1])-1);}
}

for($j=0; $j<= $#shipdata; $j++){
	for($k=$j; $k<=$#shipdata; $k++){
#		print "$shipdata[$j][3] $shipdata[$k][3]\n";
		if($shipdata[$k][0] != $shipdata[$j][0] && $shipdata[$k][0] <= $major[$#major] && $shipdata[$j][0] <= $major[$#major] && $shipdata[$j][3] > 2 && $shipdata[$k][3] > 2 && $shipdata[$k][3] < 12 && $shipdata[$k][3] < 12){
			$pair = "$shipdata[$j][1]"." vs "."$shipdata[$k][1]";
			$subpath = "Major"."$shipdata[$j][0]";
#			print "$shipdata[$j][0] $shipdata[$k][0]";
			print "$subpath $j $k $pair\n";
			open(INFILE,">CombatScript.txt") || die "could not fine file CombatScript.txt\n";
				for($i=0;$i<=3;$i++){print INFILE "$template[$i]";}
				print INFILE "$template[4]";
				print INFILE "$rep\n";
				print INFILE "$template[6]";
				print INFILE "1\n";
				print INFILE "$template[8]";
				print INFILE "MAJOR"."$shipdata[$j][0]\n";
				print INFILE "$template[10]";
				print INFILE "$shipdata[$j][1]\n";
				print INFILE "$template[12]";
				print INFILE "MAJOR"."$shipdata[$k][0]\n";
				print INFILE "$template[14]";
				print INFILE "$shipdata[$k][1]\n";
			close(INFILE);
			system("wine $combatsim");
			open(OFILE, "<Stats.log") || die "could not open Stats.log\n";
				@out = <OFILE>;
			close(OFILE);
			foreach(@out){
				print "$_";
				if($_ =~ /race:/){
					my @tmp = split(/\s+/,$_);
					for($i=0;$i<=$#tmp;$i++){ print "$i  $tmp[$i]\n";}
					if($tmp[1] eq "MAJOR"."$shipdata[$j][0]"){
						$table[$j][$k] = $tmp[3]/$rep*100;
						$table[$k][$j] = 100 - $table[$j][$k];
					}else{
						$table[$k][$j] = $tmp[3]/$rep*100;
						$table[$j][$k] = 100 - $table[$k][$j];
					}
					last;
				}
			}
			print "$table[$j][$k]  $table[$k][$j]\n";
#			system("mv Stats.log Stats_"."$j"."_"."$k".".log"); # use this only for debugging
		}else{
			$table[$j][$k] = "NA";
			$table[$k][$j] = "NA";
		}
			
	}
}

open(SUMF,">summary.csv") || die "can not open summary\n";
print SUMF "ship 1 /ship 2; ";
for($i=0;$i<$#shipdata;$i++){
	print SUMF "$shipdata[$i][1]; ";
}
print SUMF "$shipdata[$#shipdata][1]\n";
for($i=0;$i<=$#shipdata;$i++){
	print SUMF "$shipdata[$i][1]; ";
	for($j=0;$j<$#shipdata;$j++){
		print SUMF "$table[$i][$j]; ";
	}
	print SUMF "$table[$#shipdata][$#shipdata]\n";
}
close(SUMF);

print "TIME USED : ";
print time() - $start;
print "\n";

